# EP Parse
#
# input:  ether\\*.ep
# output: EPParse.tab
#

import os
import sys
import re
import string
import glob
from _ShiftersPaths import *

def ParseEPFile(filename):

    if not os.path.exists(filename) :
        print 'File \"' + filename + '\" does not exits.'
        sys.exit()
    
    levelname = os.path.splitext(os.path.basename(filename))[0]
    levelname = re.sub("_","-",levelname)

    reSND      = re.compile(".*SND:.*")
    reSNDsplit = re.compile("SND:")

    data = []

    f = open( filename, 'r' )
    while 1:
        line = f.readline()
        if not line:
           break
        if ( reSND.match(line) ):
            sp = reSNDsplit.split(line)[1]
            sound = string.lower(re.split("\"", sp)[0])
            datum = (levelname,sound)
            if not datum in data:
                data.append(datum)
    f.close()

    for datum in data:
        level = datum[0]
        sound = datum[1]
        if len(sound) > 0 :
		    print level + '\t' + sound

def ParseAllEPFiles():

    print "EPParse"

    f_out = open( "_EPParse.tab",'w')
    console = sys.stdout
    sys.stdout = f_out
    
    filenames = glob.glob(kShiftersCodePath + "ether\\*.ep")
    for filename in filenames:
        ParseEPFile(filename)

    sys.stdout = console
    f_out.close()

if __name__ == '__main__':
    ParseAllEPFiles()
