#
# ROLparse.py
#
# input:  "ed_maps\\*.rol"
# ouput:  "rolparseall.tab"

import os
import sys
import re
import string
import glob
from _ShiftersPaths import *

kSoundFlag = 21

class Element:
    def __init__(self):
        self.name = ""
        self.properties = []
        self.level = ""
    def report(self):
        print 'Element\t' + '\t' + self.name

class Group(Element):
    def __init__(self):
        self.children = []
    def report(self):
        #print 'Group\t' + self.name
        for child in self.children:
            child.report()

class Entity(Element):
    def __init__(self):
        self.type = ""
    def report(self):
        print self.level + '\tEntity\t' + self.name + '\t' + self.type
    def parse(self,f):
        line = string.strip(f.readline())
        if not re.match("{",line):
            print "Invalid entity record"
            return
        while 1:
            line = string.strip(f.readline())
            if re.match("}",line):
                return
            if ( re.match("type=",line) ):
                self.type = (string.split(string.split(line,"=")[1],":"))[0]

class Flag(Element):
    def __init__(self):
        self.flagtype = 0
        self.sound = ""
    def report(self):
        #flagtypestr = str(self.flagtype)
        #if self.flagtype == kSoundFlag:
        #    flagtypestr = "SOUND"
        print self.level + '\tFlag\t' + self.name + '\t' + self.sound
    def parse(self,f):
        line = string.strip(f.readline())
        if not re.match("{",line):
            print "Invalid entity record"
            return
        while 1:
            line = string.strip(f.readline())
            if re.match("}",line):
                return
            if ( re.match("type=",line) ):
                self.flagtype = string.atoi(string.split(string.split(line,"=")[1],":")[0])
            if ( re.match("soundID",line) ):
                self.sound = string.split(line,"=")[1]
                if re.match("SND:",self.sound) or re.match("SND\\\:",self.sound) :
                    self.sound = self.sound.split(':')[1]
        
def parsefile( filename, root ):
    levelname = os.path.splitext(os.path.basename(filename))[0]
    reEntity = re.compile("Entity=")
    reFlag   = re.compile("Flag=")
    reSND  = re.compile(".*SND:.*")
    reSND2 = re.compile("SND:")
    f = open( filename, 'r' )
    while 1:
        line = f.readline()
        if not line:
           break
        line = string.strip(line)
        if ( reEntity.match(line) ):
            entity = Entity()
            entity.name = string.split(line,"=")[1]
            entity.level = levelname
            entity.parse(f)
            root.children.append(entity)
        if ( reFlag.match(line) ):
            flag = Flag()
            flag.name = string.split(line,"=")[1]
            flag.level = levelname
            flag.parse(f)
            if flag.flagtype == kSoundFlag:
                root.children.append(flag)
    f.close()
    
    f = open( filename, 'r' )
    while 1:
        line = f.readline()
        if not line:
           break
        line = string.strip(line)
        if ( reSND.match(line) ):   
            sp = reSND2.split(line)
            sound = re.split("\"", sp[1])[0]
            flag = Flag()
            flag.name = "NULL"
            flag.level = levelname
            flag.flagtype = kSoundFlag
            flag.sound = sound
            root.children.append(flag)        
    f.close()

def ROLparseALL():
    print "ROLparse"
    
    f_out = open("_ROLparse.tab",'w')
    console = sys.stdout
    sys.stdout = f_out    
        
    # filenames = glob.glob(kShiftersRuntimePath + "ed_maps\\*.rol")

    f_levels = open(kCapList)
    levels = []        
    for line in f_levels.readlines():
        level = string.split(string.lower(string.strip(line)),'\t')[0]
        if not level in levels:
            levels.append(level)
    f_levels.close()

    for level in levels:
        filenames = glob.glob(kShiftersRuntimePath + "ed_maps\\" + level + ".rol")
        if len(filenames) == 1:
            filename = filenames[0]
            sys.stdout = console
            print " processing " + filename
            sys.stdout = f_out
            world = Group()
            world.name = filename
            parsefile(filename,world)
            world.report()
            world = None
        else:
            print str(level) + " NOT FOUND"

    sys.stdout = console
    f_out.close()

if __name__ == '__main__':
    ROLparseALL()
